C DATE.FOR

C Creates an RFC822/RFC1036/RFC977/RFC1123 compliant date/time.

C Format of a legal date:
C
C	dd mmm yyyy hh:mm shhmm
C
C preferred zones are in the format +/-HHMM.  Thus, Tucson, Arizona is
C always -0700 (measured from GMT).  Those of you with the weird desire
C to change your clocks twice a year will have to twiddle NNTP_TIMEZONE
C to tell VNEWS what timezome to put in the message.  It is preferable
C to pass the time in a meaningful "local time" rather than GMT,
C although there is a cabalistic move (see NNTP P-DRAFT) to require 
C GMT.  

	Subroutine RFC_Date(Date,Timezone)

	Implicit None

C Parameters.  NOTE: Date MUST be at least 23 characters!

	Character*(*) Date
	Character*(*) Timezone

C                          11111111112222
C                 12345678901234567890123
C	Date   = 'dd mmm yyyy hh:mm +zone'
C	VMSbuf = 'dd-MMM-yyyy hh:mm:ss.cc'

C Local variables

	Character*23 vmsbuf
	Character*36 upmon /'JANFEBMARAPRMAYJUNJULAUGSEPOCTNOVDEC'/
	Character*36 lowmon/'JanFebMarAprMayJunJulAugSepOctNovDec'/
	
	Integer*4 offset

C Begin RFC_DATE

	If (Len(Date) .LT. 23) GOTO 888

	Call  SYS$ASCTIM ( 	,		! length
	1			vmsbuf,		! VMS time buffer
	2			,		! input time
	3				)	! conversion flag

	Date(1:17) = vmsbuf(1:17)	! dd-mmm-yyyy hh:mm
	Date(3:3) = ' '			! clear out the dashes
	Date(7:7) = ' '			! ... from VMS
	Date(18:18) = ' '		! and put a space for the zone.

	offset = index(upmon,vmsbuf(4:6))

	If (offset .lt. 1) GOTO 888

	Date(4:6) = lowmon(offset:offset+2)

	Date(19:) = Timezone

	Return

888	Write (6,*) 'Invalid parameter/internal error in RFC_Date.'
	Date = '16 Jan 1964 19:31 -0700'
	Return

	End
